import { Navigate, useLocation } from "react-router-dom";
import PageNotFound from "../common/lib/PageNotFound";
import { MultiLang } from "../config";

interface Props {
    lang: MultiLang;
}

const XoonipsXoopsPathRedirect: React.FC<Props> = (props: Props) => {
    const { lang } = props;
    const location = useLocation();
    const getRedirectUrl = () => {
        const pathname = location.pathname || "";
        // const query = new URLSearchParams(location.search);
        const search = new RegExp("^/modules/xoonips(?:/+(.*))?$");
        const matches = pathname.match(search);
        if (matches === null) {
            return "";
        }
        const path = matches[1] || "";
        switch (path) {
            case "":
            case "index.php": {
                return "/modules/xoonips";
            }
        }
        return "";
    };
    const url = getRedirectUrl();
    if (url === "") {
        return <PageNotFound lang={lang} />;
    }
    return <Navigate to={url} />;
};

export default XoonipsXoopsPathRedirect;
